import .lnat
import .ftable
open lnat
open table
open nat

namespace subst
  inductive is_free : var -> exp -> Prop :=
  | var : Pi x, is_free x (exp.var x)
  | lam : Pi {x y e}, Pi t, not (x = y) -> is_free x e -> is_free x (exp.lam y t e)
  | ap_left : Pi {x e}, Pi e', is_free x e -> is_free x (exp.ap e e')
  | ap_right : Pi {x e}, Pi e', is_free x e -> is_free x (exp.ap e' e)

  inductive aequiv : exp -> exp -> Prop :=
  | id : Pi e, aequiv e e
  | ap : Pi {e1 e1' e2 e2'}, aequiv e1 e1' -> aequiv e2 e2' -> aequiv (exp.ap e1 e2) (exp.ap e1' e2')
  | lam : Pi {x y e e' e''}, Pi t, is_subst e' x (exp.var y) e'' -> aequiv e e' -> aequiv (exp.lam x t e) (exp.lam y t e'')

  with is_subst : exp -> var -> exp -> exp -> Prop :=
  | var_eq : Pi x e, is_subst (exp.var x) x e e
  | var_ne : Pi {x y}, Pi e, not (x = y) -> is_subst (exp.var y) x e (exp.var y)
  | const : Pi c x e, is_subst (exp.const c) x e (exp.const c)
  | ap : Pi {x e e1 e1' e2 e2'}, is_subst e1 x e e1' -> is_subst e2 x e e2' -> is_subst (exp.ap e1 e2) x e (exp.ap e1' e2')
  | lam_ne : Pi {x y z t e e1 e1' e1''}, not (x = y) ->
      not (is_free z e) ->
      aequiv (exp.lam y t e1) (exp.lam z t e1') ->
      is_subst e1' x e e1'' ->
      is_subst (exp.lam y t e1) x e (exp.lam z t e1'')

  -- this is very complicated to prove, so fuck it
  axiom exists_subst : forall e1 x e, exists e1', is_subst e1 x e e1'

  namespace is_subst
    theorem trans : forall {x y e e1 e1' e1''}, is_subst e1 x (exp.var y) e1' -> is_subst e1' y e e1'' -> is_subst e1 x e e1'' := sorry
  end is_subst

  -- the substitution lemma
  theorem preserves_types : forall {c c' x t _e e' t' e},
    is_unionr c (singleton x t) c' ->
    exp.has_typ c _e t ->
    exp.has_typ c' e' t' ->
    is_subst e' x _e e ->
    exp.has_typ c e t' := sorry

end subst
