-- TODO Finish typechecking completeness

import .ftable
import .lnat
open lnat
open nat

definition typecheck [reducible] : ctx -> exp -> option typ
| typecheck c (exp.var x) := table.find c x
| typecheck c (exp.const const.z) := option.some typ.nat
| typecheck c (exp.const const.s) := option.some (typ.arr typ.nat typ.nat)
| typecheck c (exp.lam x t e) :=
    match typecheck (table.unionr c (table.singleton x t)) e with
    | option.some t' := option.some (typ.arr t t')
    | option.none := option.none
    end
| typecheck c (exp.ap e1 e2) :=
    match typecheck c e1 with
    | option.some (typ.arr t1 t2) :=
        match typecheck c e2 with
        | option.some t1' := @ite (t1 = t1') (typ.decidable_eq t1 t1') (option typ) (option.some t2) option.none
        | _ := option.none
        end
    | _ := option.none
    end

-- error : pattern matcher failed; another lean bug?
theorem sound : forall e c t, typecheck c e = option.some t -> exp.has_typ c e t := sorry
-- | sound (exp.var x) c t H :=
--     have Peq : table.find c x = option.some t, from eq.subst rfl H,
--     have P : table.contains c x t, from iff.elim_left (table.find_contains c x t) Peq,
--     show exp.has_typ c (exp.var x) t, from exp.has_typ.var P
-- | sound (exp.const const.z) c t H :=
--     have P : exp.has_typ c (exp.const const.z) typ.nat, from exp.has_typ.const c (const.has_typ.z),
--     have Peq : option.some typ.nat = option.some t, from eq.subst rfl H,
--     show exp.has_typ c (exp.const const.z) t, from eq.subst (option.some.inj Peq) P
-- | sound (exp.const const.s) c t H :=
--     have P : exp.has_typ c (exp.const const.s) (typ.arr typ.nat typ.nat), from exp.has_typ.const c (const.has_typ.s),
--     have Peq : option.some (typ.arr typ.nat typ.nat) = option.some t, from eq.subst rfl H,
--     show exp.has_typ c (exp.const const.s) t, from eq.subst (option.some.inj Peq) P
-- | sound (exp.lam x t e) c t' H :=
--     have IH : forall c t, typecheck c e = option.some t -> exp.has_typ c e t, from @sound e,
--     let xt : ctx := table.singleton x t in
--     let c' : ctx := table.unionr c xt in
--     have P1 : table.is_unionr c xt c', from table.unionr_is_unionr c xt,
--     have P2 : exists t'', exp.has_typ c' e t'' /\ t' = typ.arr t t'', from
--     option.rec_on (typecheck (table.unionr c (table.singleton x t)) e)
--     ( assume Hbad : typecheck (table.unionr c (table.singleton x t)) e = option.none,
--       have P : typecheck c (exp.lam x t e) = option.none,
--         from eq.subst Hbad (@rfl (option typ) (typecheck c (exp.lam x t e))),
--       absurd (eq.subst P H) (option.none_ne_some t') )
--     ( take t'',
--       assume H' : typecheck c' e = option.some t'',
--       have P1 : exp.has_typ c' e t'', from IH c' t'' H',
--       have P : typecheck c (exp.lam x t e) = option.some (typ.arr t t''),
--         from eq.subst H' (@rfl (option typ) (typecheck c (exp.lam x t e))),
--       have P2 : t' = typ.arr t t'', from option.some.inj (eq.subst H P),
--       exists.intro t'' (and.intro P1 P2) ) rfl,
--     show exp.has_typ c (exp.lam x t e) t', from exists.elim P2
--     ( take t'', assume H : exp.has_typ c' e t'' /\ t' = typ.arr t t'',
--       have P : exp.has_typ c (exp.lam x t e) (typ.arr t t''), from exp.has_typ.lam P1 (and.elim_left H),
--       eq.subst (eq.symm (and.elim_right H)) P )

-- TODO figure out why dependent pattern matching doesn't work here
-- Maybe doing this via contradiction may be better?
theorem complete : forall e c t, exp.has_typ c e t -> typecheck c e = option.some t
| complete (exp.var x) c t H :=
  have P : table.find c x = option.some t, from exp.has_typ.var.inv H,
  show typecheck c (exp.var x) = option.some t, from eq.subst P rfl
| complete (exp.const const.z) c t H :=
    have Peq : t = typ.nat, from sorry,
    eq.subst (eq.symm Peq) rfl
| complete e c t H := sorry
